package tcc.haruki.domain.xtr;

import java.math.BigInteger;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;

import tcc.haruki.domain.XTRElem;
import tcc.haruki.domain.GaloisField;
import tcc.haruki.exceptions.XTRInvalidParametersException;
import tcc.haruki.exceptions.XTRInvalidKeyException;
import tcc.haruki.exceptions.XTRNullParametersException;
import tcc.haruki.services.XTROperationService;
import tcc.haruki.services.impl.XTRDefaultOperationService;

public class XTRKeyTest {
	
	private XTRParameters params;
	private XTRKey key;
	private XTROperationService service;
	private GaloisField gf;
	
	@Before
	public void setup() throws XTRNullParametersException, XTRInvalidParametersException, XTRInvalidKeyException {
		params = Mockito.mock(XTRParameters.class);
		Mockito.when(params.getP()).thenReturn(new BigInteger("179"));
		gf = new GaloisField(params.getP());
		Mockito.when(params.getQ()).thenReturn(new BigInteger("43"));
		Mockito.when(params.getGF()).thenReturn(gf);
		Mockito.when(params.isValid()).thenReturn(true);
		key = XTRKey.generateXTRKey(params);
		service = new XTRDefaultOperationService(params);
	}
	
}
